/*
 *  Render.h
 *  Tcc
 */

#ifndef _LAYOUT_h
#define _LAYOUT_h

#include <QMainWindow>
#include "ui_Layout.h"
//#include "vtkmsqImageProperties.h"
//#include "vtkImageData.h"

class vtkEventQtSlotConnect;
class vtkColorTransferFunction;
class vtkPiecewiseFunction;
class vtkRenderer;
class vtkLookupTable;
class vtkImageData;
class vtkmsqImageProperties;

class Render : public QMainWindow, public Ui::Layout
{
	Q_OBJECT
public:
	Render();
	~Render();

protected:
	vtkPiecewiseFunction *opacityTransferFunction;
	vtkColorTransferFunction *colorTransferFunction;
	vtkmsqImageProperties *properties;
	vtkImageData *image;
	vtkRenderer *renderer;
	vtkLookupTable *colorMap;

	QString currentFileName;
	QString currentFilter;

private:
	int loadAnalyzeImage(const QString &); 
	void warningMessage(const QString &, const QString &);
	void setCurrentFile(const QString &);
	void configureButtons(int min, int max);
	void insertRow(int intensity, int R, int G, int B, int A);
	void disableButtons();

private slots:
	void AddRGBAPoint();
	void RemoveRGBAPoint();
	void fileOpen();
	void updateRGBA();
	void changeToBlack();
	void changeToWhite();
};

#endif
